// CustomDlg.cpp : implementation file
//
/*  CCustomDlg class for Custom Mp3 Format specification
    Copyright (C) 2001-2003 John George K., xeonfusion@users.sourceforge.net
	
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/


#include "stdafx.h"
#include "resource.h"
#include "CustomDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCustomDlg dialog


CCustomDlg::CCustomDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCustomDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCustomDlg)
	m_leadzero1 = _T("0");
	m_leadzero2 = _T("0");
	m_custommp3format = _T("");
	m_separatorstr = _T("");
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_cftagmap["<Ignore>"]= "0";
	m_cftagmap["<Artist>"]= "1";
	m_cftagmap["<Title>"]= "2";
	m_cftagmap["<Album>"]= "3";
	m_cftagmap["<Year>"]= "4";
	m_cftagmap["<Comment>"]= "5";
	m_cftagmap["<Track>"]= "6";

	m_taglist.AddHead("<Artist>");
	m_taglist.AddTail("<Title>");

	m_bUseLeadZero = FALSE;
	m_bappendbit = FALSE;
	m_bappendmode = FALSE;
}


void CCustomDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCustomDlg)
	DDX_Control(pDX, IDC_SEPARATOR_COMBO, m_separatorcombo);
	DDX_Control(pDX, IDC_FILENAMEFORMAT_EDIT, m_formatviewedit);
	DDX_Control(pDX, IDC_APPENDMODE_CHECK, m_appendmodechk);
	DDX_Control(pDX, IDC_APPENDBIT_CHECK, m_appendbitchk);
	DDX_Control(pDX, IDC_LEADZERO_CHECK, m_leadzerochk);
	DDX_Control(pDX, IDC_YEARFORMAT_CHK, m_yearformatchk);
	DDX_Control(pDX, IDC_TRACKFORMAT_CHK, m_trackformatchk);
	DDX_Control(pDX, IDC_TITLEFORMAT_CHK, m_titleformatchk);
	DDX_Control(pDX, IDC_FORMATVIEW_LIST, m_formatviewlist);
	DDX_Control(pDX, IDC_COMMENTFORMAT_CHK, m_commentformatchk);
	DDX_Control(pDX, IDC_ARTISTFORMAT_CHK, m_artistformatchk);
	DDX_Control(pDX, IDC_ALBUMFORMAT_CHK, m_albumformatchk);
	DDX_Text(pDX, IDC_LEADZERO_EDIT1, m_leadzero1);
	DDV_MaxChars(pDX, m_leadzero1, 3);
	DDX_Text(pDX, IDC_LEADZERO_EDIT2, m_leadzero2);
	DDV_MaxChars(pDX, m_leadzero2, 3);
	DDX_Text(pDX, IDC_FILENAMEFORMAT_EDIT, m_custommp3format);
	DDX_CBString(pDX, IDC_SEPARATOR_COMBO, m_separatorstr);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCustomDlg, CDialog)
	//{{AFX_MSG_MAP(CCustomDlg)
	ON_BN_CLICKED(IDC_ARTISTFORMAT_CHK, OnArtistformatChk)
	ON_BN_CLICKED(IDC_TITLEFORMAT_CHK, OnTitleformatChk)
	ON_BN_CLICKED(IDC_ALBUMFORMAT_CHK, OnAlbumformatChk)
	ON_BN_CLICKED(IDC_YEARFORMAT_CHK, OnYearformatChk)
	ON_BN_CLICKED(IDC_COMMENTFORMAT_CHK, OnCommentformatChk)
	ON_BN_CLICKED(IDC_TRACKFORMAT_CHK, OnTrackformatChk)
	ON_BN_CLICKED(IDC_MOVEUP_BUTTON, OnMoveupButton)
	ON_BN_CLICKED(IDC_MOVEDOWN_BUTTON, OnMovedownButton)
	ON_BN_CLICKED(IDC_LEADZERO_CHECK, OnLeadzeroCheck)
	ON_BN_CLICKED(IDC_APPENDBIT_CHECK, OnAppendbitCheck)
	ON_BN_CLICKED(IDC_APPENDMODE_CHECK, OnAppendmodeCheck)
	ON_BN_CLICKED(IDC_IGNORE_BUTTON, OnIgnoreButton)
	ON_BN_CLICKED(IDC_EMPTYFORMAT_BUTTON, OnEmptyformatButton)
	ON_BN_CLICKED(IDC_ADDSEPARATOR_BUTTON, OnAddseparatorButton)
	ON_EN_CHANGE(IDC_FILENAMEFORMAT_EDIT, OnChangeFilenameformatEdit)
	ON_BN_CLICKED(IDC_STOREFORMAT_BUTTON, OnStoreformatButton)
	ON_LBN_SELCHANGE(IDC_FORMATVIEW_LIST, OnSelchangeFormatviewList)
	ON_BN_CLICKED(IDC_EDITFORMAT_BUTTON, OnEditformatButton)
	ON_BN_CLICKED(IDC_DELETEFORMAT_BUTTON, OnDeleteformatButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCustomDlg message handlers

void CCustomDlg::RemoveAllChksItems()
{
	m_artistformatchk.SetCheck(0);
	m_titleformatchk.SetCheck(0);
	m_albumformatchk.SetCheck(0);
	m_yearformatchk.SetCheck(0);
	m_commentformatchk.SetCheck(0);
	m_trackformatchk.SetCheck(0);

}


BOOL CCustomDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	
	m_separatorstr = _T(" - ");
	RemoveAllChksItems();
	CompareTagIdSetChks();
		
	m_formatviewlist.ResetContent();
	POSITION p = m_filenameformatlist.GetHeadPosition();
		while (p!=NULL)
		{
			CString s = m_filenameformatlist.GetNext(p);
			m_formatviewlist.AddString(LPCTSTR(s));
			
		}
	if(m_formatviewlist.GetCount())
	{
		int nsel = m_formatviewlist.FindStringExact(-1,LPCTSTR(m_custommp3format));
		m_formatviewlist.SetCurSel(nsel);
	}

	if(m_bUseLeadZero) m_leadzerochk.SetCheck(1);
	OnLeadzeroCheck();
	if(m_bappendbit) m_appendbitchk.SetCheck(1);
	if(m_bappendmode) m_appendmodechk.SetCheck(1);
	 
	UpdateData(FALSE);

	m_formatviewedit.SetFocus();
	m_formatviewedit.SendMessage(WM_KEYDOWN,VK_END,0);

	return FALSE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE

}

void CCustomDlg::OnArtistformatChk() 
{
	UpdateData(TRUE);
	CString szTag = _T("<Artist>");
	if (m_artistformatchk.GetCheck() == 1)
	{
		m_formatviewedit.ReplaceSel(szTag);
	}
	else
	{
		FindReplaceFileFormatEdit(szTag,_T(""));
	}
	UpdateData(FALSE);
	m_formatviewedit.SetFocus();
	
}

void CCustomDlg::OnTitleformatChk() 
{
	UpdateData(TRUE);
	CString szTag = _T("<Title>");
	if (m_titleformatchk.GetCheck() == 1)
	{
		m_formatviewedit.ReplaceSel(szTag);
	}
	else
	{
		FindReplaceFileFormatEdit(szTag,_T(""));
	}
	UpdateData(FALSE);
	m_formatviewedit.SetFocus();
	
}

void CCustomDlg::OnAlbumformatChk() 
{
	UpdateData(TRUE);
	CString szTag = _T("<Album>");
	if (m_albumformatchk.GetCheck() == 1)
	{
		m_formatviewedit.ReplaceSel(szTag);
	}
	else
	{
		FindReplaceFileFormatEdit(szTag,_T(""));
	}
	UpdateData(FALSE);
	m_formatviewedit.SetFocus();
	
}

void CCustomDlg::OnYearformatChk() 
{
	UpdateData(TRUE);
	CString szTag = _T("<Year>");
	if (m_yearformatchk.GetCheck() == 1)
	{
		m_formatviewedit.ReplaceSel(szTag);
	}
	else
	{
		FindReplaceFileFormatEdit(szTag,_T(""));
	}
	UpdateData(FALSE);
	m_formatviewedit.SetFocus();
	
}

void CCustomDlg::OnCommentformatChk() 
{
	UpdateData(TRUE);
	CString szTag = _T("<Comment>");
	if (m_commentformatchk.GetCheck() == 1)
	{
		m_formatviewedit.ReplaceSel(szTag);
	}
	else
	{
		FindReplaceFileFormatEdit(szTag,_T(""));
	}
	UpdateData(FALSE);
	m_formatviewedit.SetFocus();
	
}

void CCustomDlg::OnTrackformatChk() 
{
	UpdateData(TRUE);
	CString szTag = _T("<Track>");
	if (m_trackformatchk.GetCheck() == 1)
	{
		m_formatviewedit.ReplaceSel(szTag);
	}
	else
	{
		FindReplaceFileFormatEdit(szTag,_T(""));
	}
	UpdateData(FALSE);
	m_formatviewedit.SetFocus();
	
}

void CCustomDlg::OnMoveupButton() 
{
	int sel;
	sel = m_formatviewlist.GetCurSel();
	if (sel != -1)
	{
		CString selstr;
		int listcount;
		listcount = m_formatviewlist.GetCount();
		m_formatviewlist.GetText(sel, selstr);
		m_formatviewlist.DeleteString(sel);
		if (sel != 0)
		{
			m_formatviewlist.InsertString(sel-1, LPCTSTR(selstr));
			m_formatviewlist.SetCurSel(sel-1);
		}
		else
		{
			m_formatviewlist.InsertString(listcount-1, LPCTSTR(selstr));
			m_formatviewlist.SetCurSel(listcount-1);
		}
			
	}

	
}

void CCustomDlg::OnMovedownButton() 
{
	int sel;
	sel = m_formatviewlist.GetCurSel();
	if (sel != -1)
	{
		CString selstr;
		int listcount;
		listcount = m_formatviewlist.GetCount();
		m_formatviewlist.GetText(sel, selstr);
		m_formatviewlist.DeleteString(sel);
		if (sel != (listcount-1))
		{
			m_formatviewlist.InsertString(sel+1, LPCTSTR(selstr));
			m_formatviewlist.SetCurSel(sel+1);
		}
		else
		{
			m_formatviewlist.InsertString(0, LPCTSTR(selstr));
			m_formatviewlist.SetCurSel(0);
		}
			
	}
	
}

void CCustomDlg::OnLeadzeroCheck() 
{
	CWnd* pWnd1 = GetDlgItem(IDC_LEADZERO_EDIT1);
	CWnd* pWnd2 = GetDlgItem(IDC_LEADZERO_EDIT2);

	if (m_leadzerochk.GetCheck() == 1)
	{
		m_bUseLeadZero = TRUE;
		pWnd1->EnableWindow(TRUE);
		pWnd2->EnableWindow(TRUE);
	}
	else
	{
		m_bUseLeadZero = FALSE;
		pWnd1->EnableWindow(FALSE);
		pWnd2->EnableWindow(FALSE);
	}
}

void CCustomDlg::OnAppendbitCheck() 
{
	if (m_appendbitchk.GetCheck() == 1) m_bappendbit = TRUE;
	else m_bappendbit = FALSE;
	
}

void CCustomDlg::OnAppendmodeCheck() 
{
	if (m_appendmodechk.GetCheck() == 1) m_bappendmode = TRUE;
	else m_bappendmode = FALSE;
	
}



void CCustomDlg::CompareTagIdSetChks()
{
	POSITION pos = m_taglist.GetHeadPosition();
	

	while (pos != NULL)
	{
		CString tagidstr;
		CString cftagstr;
		int tagid;
		
		cftagstr = m_taglist.GetNext(pos);

		if (!cftagstr.IsEmpty())
		{
			m_cftagmap.Lookup(cftagstr, tagidstr);
			tagid = atoi(LPCTSTR(tagidstr));

			switch(tagid)
				{
					case 0:
						tagid = 0;
						break;
					case 1:
						tagid = 1;
						m_artistformatchk.SetCheck(1);
						break;
					case 2:
						tagid = 2;
						m_titleformatchk.SetCheck(1);
						break;
					case 3:
						tagid = 3;
						m_albumformatchk.SetCheck(1);
						break;
					case 4:
						tagid = 4;
						m_yearformatchk.SetCheck(1);
						break;
					case 5:
						tagid = 5;
						m_commentformatchk.SetCheck(1);
						break;
					case 6:
						tagid = 6;
						m_trackformatchk.SetCheck(1);
						break;
					default:
						AfxMessageBox("Error setting checks for custom format");
						break;

				}
		}
	}

}

BOOL CCustomDlg::TestValidSeparator(CString szSeparator)
{
	if(szSeparator.IsEmpty())
	{
		MessageBox(_T("A Null(empty) Separator has been used"), "Mp3 Tag Tools", MB_OK | MB_ICONERROR);
		return FALSE;
	}

	char ch1 = 0x5C; char ch2 = 0x22; 
	CString charset = "/:*?<>|";
	charset = ch1 + charset +ch2; 
	CString errmsg = "a filename can't contain any of the following ";
	errmsg += charset;
	int pos = szSeparator.FindOneOf(LPCTSTR(charset));
	if(pos != -1)
	{
		
		MessageBox(LPCTSTR(errmsg), "Mp3 Tag Tools", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	else return TRUE;
}

void CCustomDlg::OnIgnoreButton() 
{
	UpdateData(TRUE);
	m_formatviewedit.ReplaceSel(_T("<Ignore>"));
	UpdateData(FALSE);	
}

void CCustomDlg::OnEmptyformatButton() 
{
	UpdateData(TRUE);
	m_custommp3format = _T("");
	RemoveAllChksItems();
	UpdateData(FALSE);
	m_formatviewedit.SetFocus();
	m_formatviewedit.SendMessage(WM_KEYDOWN,VK_END,0);
}

void CCustomDlg::OnAddseparatorButton() 
{
	UpdateData(TRUE);
	m_custommp3format += m_separatorstr;
	m_formatviewedit.ReplaceSel(LPCTSTR(m_separatorstr));
	UpdateData(FALSE);
	m_formatviewedit.SetFocus();
	
}

void CCustomDlg::OnChangeFilenameformatEdit() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	
	UpdateData(TRUE);	
	if(FindReplaceFileFormatEdit(_T("*1"),_T("<Artist>")))
	m_artistformatchk.SetCheck(TRUE);
	if(FindReplaceFileFormatEdit(_T("*2"),_T("<Title>")))
	m_titleformatchk.SetCheck(TRUE);
	if(FindReplaceFileFormatEdit(_T("*3"),_T("<Album>")))
	m_albumformatchk.SetCheck(TRUE);
	if(FindReplaceFileFormatEdit(_T("*4"),_T("<Year>")))
	m_yearformatchk.SetCheck(TRUE);
	if(FindReplaceFileFormatEdit(_T("*5"),_T("<Comment>")))
	m_commentformatchk.SetCheck(TRUE);
	if(FindReplaceFileFormatEdit(_T("*6"),_T("<Track>")))
	m_trackformatchk.SetCheck(TRUE);
	FindReplaceFileFormatEdit(_T("*0"),_T("<Ignore>"));
	UpdateData(FALSE);
	m_formatviewedit.SetFocus();
	
}

int CCustomDlg::FindReplaceFileFormatEdit(CString szFind, CString szReplace)
{
		int pos = m_custommp3format.Find(szFind,0);
		if(pos!=-1)
		{
		m_formatviewedit.SetSel(pos,(pos+szFind.GetLength()));
		m_formatviewedit.ReplaceSel(szReplace);
		return 1;
		}
		else return 0;
}

void CCustomDlg::OnStoreformatButton() 
{
	TestAndStoreFormat();
}

BOOL CCustomDlg::TestValidTag(CString szTag)
{
	CString tagidstr;
	if(m_cftagmap.Lookup(szTag, tagidstr)) return TRUE;
	else return FALSE;
}

BOOL CCustomDlg::TestAndStoreFormat()
{
	TestFormatCreateLists();
	if(!m_taglist.IsEmpty())
	{
		int index = m_formatviewlist.FindStringExact(-1,LPCTSTR(m_custommp3format));
		if(index == LB_ERR)
		{	
		m_formatviewlist.InsertString(0,LPCTSTR(m_custommp3format));
		m_formatviewlist.SetCurSel(0);
		}
		else m_formatviewlist.SetCurSel(index);
		m_formatviewlist.SetFocus();
		return TRUE;
	}
	else return FALSE;
	
}

void CCustomDlg::OnOK() 
{
	UpdateData(TRUE);
	if(TestAndStoreFormat())
	{
	int listcount = m_formatviewlist.GetCount();
	CString str;
	m_filenameformatlist.RemoveAll();
	for (int n=0;n<listcount;n++)
	{
		m_formatviewlist.GetText(n, str);
		m_filenameformatlist.AddTail(LPCTSTR(str));
	}
	EndDialog(IDOK);
	}
}



void CCustomDlg::OnSelchangeFormatviewList() 
{
	CString szFormat;
	int index = m_formatviewlist.GetCurSel();
	if(index != -1)
	{
	m_formatviewlist.GetText(index, szFormat);
	m_custommp3format = szFormat;
	TestFormatCreateLists();
	RemoveAllChksItems();
	CompareTagIdSetChks();
	UpdateData(FALSE);
	}
}

void CCustomDlg::OnEditformatButton() 
{
	int index = m_formatviewlist.GetCurSel();
	if(index !=-1)
	{
	m_formatviewlist.DeleteString(index);
	}
	m_formatviewedit.SetFocus();
}

void CCustomDlg::OnDeleteformatButton() 
{
	int listcount = m_formatviewlist.GetCount();
	int index = m_formatviewlist.GetCurSel();
	if(index != -1)
	{
	m_formatviewlist.DeleteString(index);
		
	CString szFormat;
	if(index>0)
	{
	m_formatviewlist.SetCurSel(index-1);
	m_formatviewlist.GetText(index-1, szFormat);
	m_custommp3format = szFormat;
	TestFormatCreateLists();
	}
	else if(listcount>1)
	{
		m_formatviewlist.SetCurSel(index);
		m_formatviewlist.GetText(index, szFormat);
		m_custommp3format = szFormat;
		TestFormatCreateLists();
	}
	else
	{
		m_custommp3format = _T("");
		m_taglist.RemoveAll();
		m_separatorlist.RemoveAll();
	}
		
	RemoveAllChksItems();
	CompareTagIdSetChks();
	UpdateData(FALSE);
	m_formatviewlist.SetFocus();
	}
}

BOOL CCustomDlg::TestFormatCreateLists()
{
	m_taglist.RemoveAll();
	m_separatorlist.RemoveAll();
	
	int pos1,pos2,pos3 = -1;
	int stringlen;
	CString str1 = m_custommp3format;
	CString delimiter1, delimiter2, tagstr;
	
	delimiter1 = _T("<");
	delimiter2 = _T(">");

	stringlen = str1.GetLength();

	pos1 = str1.Find(LPCTSTR(delimiter1));
	pos2 = str1.Find(LPCTSTR(delimiter2), pos1);
	
	if(pos1 ==-1 || pos2 ==-1)
	{
		MessageBox(_T("Invalid Format"), "Mp3 Tag Tools", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	
	if(pos1>0) //we have a prefix
	{
		CString prefixseparator = str1.Left(pos1);
		str1 = str1.Right(stringlen - pos1);
		if(TestValidSeparator(prefixseparator))
		{
			m_prefixseparator = prefixseparator;
		}
		else
		{
			MessageBox(_T("Invalid Format"), "Mp3 Tag Tools", MB_OK | MB_ICONERROR);
			return FALSE;
		}
	}
	else m_prefixseparator = _T("");

	pos3 = str1.ReverseFind(delimiter2.GetAt(0));
	stringlen = str1.GetLength();

	if(pos3<(stringlen-1)) // we have a suffix
	{
		CString suffixseparator = str1.Right(stringlen - (pos3+1));
		str1 = str1.Left((pos3+1));
		if(TestValidSeparator(suffixseparator))
		{
			m_suffixseparator = suffixseparator;
		}
		else
		{
			MessageBox(_T("Invalid Format"), "Mp3 Tag Tools", MB_OK | MB_ICONERROR);
			return FALSE;
		}
	}
	else m_suffixseparator = _T("");
	
	stringlen = str1.GetLength();
	
	do
	{
		
		pos1 = str1.Find(LPCTSTR(delimiter1));
		pos2 = str1.Find(LPCTSTR(delimiter2), pos1);

		if(pos1 !=-1 && pos2 !=-1)
		{
			tagstr = str1.Left(pos2+1);
			str1 = str1.Right(stringlen - tagstr.GetLength());
			stringlen = str1.GetLength();
			if(TestValidTag(tagstr))
			{
				m_taglist.AddTail(LPCTSTR(tagstr));
				
			}
			else
			{
				m_taglist.RemoveAll();
				m_separatorlist.RemoveAll();
				MessageBox(_T("Invalid Format"), "Mp3 Tag Tools", MB_OK | MB_ICONERROR);
				return FALSE;
			}
		}
		else
		{
			m_taglist.RemoveAll();
			m_separatorlist.RemoveAll();
			MessageBox(_T("Invalid Format"), "Mp3 Tag Tools", MB_OK | MB_ICONERROR);
			break;
		}

		if(stringlen == 0) break;
		pos1 = str1.Find(LPCTSTR(delimiter1));
		pos2 = str1.Find(LPCTSTR(delimiter2), pos1);

		if(pos1 !=-1 && pos2 !=-1)
		{
			CString separatorstr = str1.Left(pos1);
			if(TestValidSeparator(separatorstr))
			{
				m_separatorlist.AddTail(LPCTSTR(separatorstr));
			}
			else
			{
				m_taglist.RemoveAll();
				m_separatorlist.RemoveAll();
				MessageBox(_T("Invalid Format"), "Mp3 Tag Tools", MB_OK | MB_ICONERROR);
				return FALSE;
			}
			str1 = str1.Right(stringlen - separatorstr.GetLength());
			stringlen = str1.GetLength();
		}
		else
		{
			m_taglist.RemoveAll();
			m_separatorlist.RemoveAll();
			MessageBox(_T("Invalid Format"), "Mp3 Tag Tools", MB_OK | MB_ICONERROR);
			break;
		}
	}
	while(!str1.IsEmpty());

	if(m_taglist.IsEmpty()) return FALSE;
	else return TRUE;
	
	
}
