/*  CCustomDlg class for Custom Mp3 Format specification
    Copyright (C) 2001-2003 John George K., xeonfusion@users.sourceforge.net
	
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#if !defined(AFX_CUSTOMDLG_H__F2FC4B86_6095_4D7F_A90B_FBDCE7280E01__INCLUDED_)
#define AFX_CUSTOMDLG_H__F2FC4B86_6095_4D7F_A90B_FBDCE7280E01__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CustomDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CCustomDlg dialog

class CCustomDlg : public CDialog
{
// Construction
public:
	CStringList m_filenameformatlist;
	BOOL TestFormatCreateLists();
	BOOL TestAndStoreFormat();
	CString m_suffixseparator;
	CString m_prefixseparator;
	CStringList m_separatorlist;
	BOOL TestValidTag(CString szTag);
	int FindReplaceFileFormatEdit(CString szFind, CString szReplace);
	BOOL TestValidSeparator(CString szSeparator);
	void CompareTagIdSetChks();
	BOOL m_bappendmode;
	BOOL m_bappendbit;
	BOOL m_bUseLeadZero;
	void RemoveAllChksItems();
	CStringList m_taglist;
	CMapStringToString m_cftagmap;
	CCustomDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CCustomDlg)
	enum { IDD = IDD_CUSTOM_FORMAT_DIALOG };
	CComboBox	m_separatorcombo;
	CEdit	m_formatviewedit;
	CButton	m_appendmodechk;
	CButton	m_appendbitchk;
	CButton	m_leadzerochk;
	CButton	m_yearformatchk;
	CButton	m_trackformatchk;
	CButton	m_titleformatchk;
	CListBox	m_formatviewlist;
	CButton	m_commentformatchk;
	CButton	m_artistformatchk;
	CButton	m_albumformatchk;
	CString	m_leadzero1;
	CString	m_leadzero2;
	CString	m_custommp3format;
	CString	m_separatorstr;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCustomDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CCustomDlg)
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	afx_msg void OnArtistformatChk();
	afx_msg void OnTitleformatChk();
	afx_msg void OnAlbumformatChk();
	afx_msg void OnYearformatChk();
	afx_msg void OnCommentformatChk();
	afx_msg void OnTrackformatChk();
	afx_msg void OnMoveupButton();
	afx_msg void OnMovedownButton();
	afx_msg void OnLeadzeroCheck();
	afx_msg void OnAppendbitCheck();
	afx_msg void OnAppendmodeCheck();
	afx_msg void OnIgnoreButton();
	afx_msg void OnEmptyformatButton();
	afx_msg void OnAddseparatorButton();
	afx_msg void OnChangeFilenameformatEdit();
	afx_msg void OnStoreformatButton();
	afx_msg void OnSelchangeFormatviewList();
	afx_msg void OnEditformatButton();
	afx_msg void OnDeleteformatButton();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CUSTOMDLG_H__F2FC4B86_6095_4D7F_A90B_FBDCE7280E01__INCLUDED_)
