// -*- C++ -*-
// $Id: misc_support_addendum.h
// Copyright 2002  John George K.
// id3lib: a C++ library for creating and manipulating id3v1/v2 tags

// This library is free software; you can redistribute it and/or modify it
// under the terms of the GNU Library General Public License as published by
// the Free Software Foundation; either version 2 of the License, or (at your
// option) any later version.
//
// This library is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library General Public
// License for more details.
//
// You should have received a copy of the GNU Library General Public License
// along with this library; if not, write to the Free Software Foundation,
// Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

// The id3lib authors encourage improvements and optimisations to be sent to
// the id3lib coordinator.  Please see the README file for details on where to
// send such submissions.  See the AUTHORS file for a list of people who have
// contributed to id3lib.  See the ChangeLog file for a list of changes to
// id3lib.  

#ifndef _ID3LIB_MISC_SUPPORT_ADDENDUM_H_
#define _ID3LIB_MISC_SUPPORT_ADDENDUM_H_

#include <id3/tag.h>
#include <misc_support.h>


ID3_Frame* ID3_AddGenre(ID3_Tag *, const char *, bool replace = false);

ID3_Frame* ID3_AddTrack(ID3_Tag *, const char *, bool replace = false);

int ID3_GetPictureData(const ID3_Tag *, const char *TempPicPath);

char* ID3_GetPictureMimeType(const ID3_Tag *);

int ID3_HasPicture(const ID3_Tag *tag);

ID3_Frame* ID3_AddPicture(ID3_Tag *, const char *TempPicPath, const char *MimeType, bool replace = false);

size_t ID3_RemovePictures(ID3_Tag *tag);

int ID3_GetPictureDataOfPicType(ID3_Tag *tag, const char *TempPicPath, int pictype);

char *ID3_GetMimeTypeOfPicType(ID3_Tag *tag, int pictype);

char *ID3_GetDescriptionOfPicType(ID3_Tag *tag, int pictype);

size_t ID3_RemovePictureType(ID3_Tag *tag, int pictype);

ID3_Frame* ID3_AddPicture(ID3_Tag *tag, const char *TempPicPath, const char *MimeType, int pictype, const char* Description, bool replace);

#endif /* _ID3LIB_MISC_SUPPORT_ADDENDUM_H_ */